//
// CustomLogging.h
//
// Created by Wagner Truppel.
// Copyright 2009 Wagner Truppel (jrcapab@gmail.com). All rights reserved.
//
// Redistribution and use in binary and source forms, with or without
// modification, are permitted for any project, commercial or otherwise,
// provided that the following conditions are met:
//
// Redistributions in binary form must display the copyright notice in the
// About view, website, and/or documentation.
//
// Redistributions of source code must retain the copyright notice, this
// list of conditions, and the following disclaimer.
//
// THIS SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY RIGHTS.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THIS SOFTWARE.

#import <Foundation/Foundation.h>

// ========================================================================= //
                           #pragma mark #defines
// ========================================================================= //

#define DEBUG

#define DEPTH_DEBUG
#define USE_WTLOG

// ========================================================================= //

#ifdef DEBUG

    #ifdef DEPTH_DEBUG

        #define WTLOG           WTTab

        #define BEGIN           LogEnter();
        #define END             LogExit();
        #define RETURN          LogExit(); return

    #else

        #ifdef USE_WTLOG
            #define WTLOG           WTLog
        #else
            #define WTLOG           NSLog
        #endif

        #define BEGIN           ;
        #define END             ;
        #define RETURN          return

    #endif

#else

    #define WTLOG           WTNil

    #define BEGIN           ;
    #define END             ;
    #define RETURN          return

#endif

// ========================================================================= //
                           #pragma mark functions
// ========================================================================= //

void WTNil(NSString *format, ...);
void WTLog(NSString *format, ...);
void WTTab(NSString *format, ...);

void LogEnter(void);
void LogExit(void);

// ========================================================================= //
